"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class BankAccountUpdateType(str, Enum):
    r"""The bank account type."""

    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    CHECKING = "CHECKING"
    SAVINGS = "SAVINGS"


class BankAccountUpdateTypedDict(TypedDict):
    r"""A representation of a bank account."""

    account_number: NotRequired[str]
    r"""The bank account number. This value will be masked in responses."""
    owner: NotRequired[str]
    r"""The name of the bank account owner."""
    routing_number: NotRequired[str]
    r"""The bank routing number (either ABA or BIC)."""
    type: NotRequired[BankAccountUpdateType]
    r"""The bank account type."""


class BankAccountUpdate(BaseModel):
    r"""A representation of a bank account."""

    account_number: Optional[str] = None
    r"""The bank account number. This value will be masked in responses."""

    owner: Optional[str] = None
    r"""The name of the bank account owner."""

    routing_number: Optional[str] = None
    r"""The bank routing number (either ABA or BIC)."""

    type: Optional[BankAccountUpdateType] = None
    r"""The bank account type."""
