"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from ascend_sdk.types import BaseModel
from enum import Enum
from typing_extensions import TypedDict


class CommissionCreateType(str, Enum):
    r"""The type of commission value being specified. Only the type of \"AMOUNT\" is supported."""

    COMMISSION_TYPE_UNSPECIFIED = "COMMISSION_TYPE_UNSPECIFIED"
    AMOUNT = "AMOUNT"


class CommissionCreateTypedDict(TypedDict):
    r"""A custom commission applied to an order"""

    type: CommissionCreateType
    r"""The type of commission value being specified. Only the type of \"AMOUNT\" is supported."""
    value: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """


class CommissionCreate(BaseModel):
    r"""A custom commission applied to an order"""

    type: CommissionCreateType
    r"""The type of commission value being specified. Only the type of \"AMOUNT\" is supported."""

    value: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
