"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class CustodialType(str, Enum):
    r"""The type of custodial account"""

    CUSTODIAL_TYPE_UNSPECIFIED = "CUSTODIAL_TYPE_UNSPECIFIED"
    UGMA = "UGMA"
    UTMA = "UTMA"


class CustodialEnrollmentMetadataCreateDividendReinvestmentPlan(str, Enum):
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to true"""

    AUTO_ENROLL_DIVIDEND_REINVESTMENT_UNSPECIFIED = (
        "AUTO_ENROLL_DIVIDEND_REINVESTMENT_UNSPECIFIED"
    )
    DIVIDEND_REINVESTMENT_ENROLL = "DIVIDEND_REINVESTMENT_ENROLL"
    DIVIDEND_REINVESTMENT_DECLINE = "DIVIDEND_REINVESTMENT_DECLINE"


class CustodialEnrollmentMetadataCreateFdicCashSweep(str, Enum):
    r"""Option to auto-enroll in FDIC cash sweep; defaults to true"""

    AUTO_ENROLL_FDIC_CASH_SWEEP_UNSPECIFIED = "AUTO_ENROLL_FDIC_CASH_SWEEP_UNSPECIFIED"
    FDIC_CASH_SWEEP_ENROLL = "FDIC_CASH_SWEEP_ENROLL"
    FDIC_CASH_SWEEP_DECLINE = "FDIC_CASH_SWEEP_DECLINE"


class CustodialEnrollmentMetadataCreateTypedDict(TypedDict):
    r"""Enrollment metadata for the CUSTODIAL enrollment type"""

    custodial_type: CustodialType
    r"""The type of custodial account"""
    dividend_reinvestment_plan: NotRequired[
        CustodialEnrollmentMetadataCreateDividendReinvestmentPlan
    ]
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to true"""
    fdic_cash_sweep: NotRequired[CustodialEnrollmentMetadataCreateFdicCashSweep]
    r"""Option to auto-enroll in FDIC cash sweep; defaults to true"""


class CustodialEnrollmentMetadataCreate(BaseModel):
    r"""Enrollment metadata for the CUSTODIAL enrollment type"""

    custodial_type: CustodialType
    r"""The type of custodial account"""

    dividend_reinvestment_plan: Optional[
        CustodialEnrollmentMetadataCreateDividendReinvestmentPlan
    ] = None
    r"""Option to auto-enroll in Dividend Reinvestment; defaults to true"""

    fdic_cash_sweep: Optional[CustodialEnrollmentMetadataCreateFdicCashSweep] = None
    r"""Option to auto-enroll in FDIC cash sweep; defaults to true"""
