"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class TransfersCreditCreateType(str, Enum):
    r"""The type of the credit being issued"""

    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    PROMOTIONAL = "PROMOTIONAL"
    WRITE_OFF = "WRITE_OFF"
    REIMBURSEMENT = "REIMBURSEMENT"


class TransfersCreditCreateTypedDict(TypedDict):
    r"""A transfer using the CREDIT mechanism. Funds are moved from a firm account to a customer's brokerage account"""

    amount: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
    client_transfer_id: str
    r"""External identifier supplied by the API caller. Each request must have a unique pairing of client_transfer_id and account"""
    type: TransfersCreditCreateType
    r"""The type of the credit being issued"""
    description: NotRequired[str]
    r"""Optional description information that will attach to this transaction"""


class TransfersCreditCreate(BaseModel):
    r"""A transfer using the CREDIT mechanism. Funds are moved from a firm account to a customer's brokerage account"""

    amount: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """

    client_transfer_id: str
    r"""External identifier supplied by the API caller. Each request must have a unique pairing of client_transfer_id and account"""

    type: TransfersCreditCreateType
    r"""The type of the credit being issued"""

    description: Optional[str] = None
    r"""Optional description information that will attach to this transaction"""
