"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .decimalcreate import DecimalCreate, DecimalCreateTypedDict
from ascend_sdk.types import BaseModel
from enum import Enum
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class TransfersFeeCreateType(str, Enum):
    r"""The type of the fee being charged"""

    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    MANAGEMENT = "MANAGEMENT"
    ADVISORY = "ADVISORY"
    EXCHANGE = "EXCHANGE"
    PLATFORM = "PLATFORM"
    INACTIVITY = "INACTIVITY"


class TransfersFeeCreateTypedDict(TypedDict):
    r"""A transfer using the FEE mechanism. Funds are moved from a customer's brokerage account to the firm account"""

    amount: DecimalCreateTypedDict
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """
    client_transfer_id: str
    r"""External identifier supplied by the API caller. Each request must have a unique pairing of client_transfer_id and account"""
    type: TransfersFeeCreateType
    r"""The type of the fee being charged"""
    description: NotRequired[str]
    r"""Optional description information that will attach to this transaction"""


class TransfersFeeCreate(BaseModel):
    r"""A transfer using the FEE mechanism. Funds are moved from a customer's brokerage account to the firm account"""

    amount: DecimalCreate
    r"""A representation of a decimal value, such as 2.5. Clients may convert values into language-native decimal formats, such as Java's [BigDecimal][] or Python's [decimal.Decimal][].

    [BigDecimal]:
    https://docs.oracle.com/en/java/javase/11/docs/api/java.base/java/math/BigDecimal.html
    [decimal.Decimal]: https://docs.python.org/3/library/decimal.html
    """

    client_transfer_id: str
    r"""External identifier supplied by the API caller. Each request must have a unique pairing of client_transfer_id and account"""

    type: TransfersFeeCreateType
    r"""The type of the fee being charged"""

    description: Optional[str] = None
    r"""Optional description information that will attach to this transaction"""
